--todo text colors for stuff?
--todo slightly randomized x for popups?

globalKillCounter = _G.globalKillCounter or {}

local GKC = globalKillCounter
GKC._localization_path = ModPath .. "loc/"
GKC._options_path = ModPath .. "options.txt"
GKC._saved_settings_path = SavePath .. "GlobalKillSettings.txt"
GKC._instance = ModInstance
GKC.neededKills = 658893

GKC.settings = {
	show_logs = false,--you need to change your save file directly if you want to show logs
	hud_compatibility_mode = true,
	hud_x = 1024,
	hud_y = 64,
	kills = 132456,
	text = "Kills: ",
	type = 1,
	font_size = 24,
}

GKC.localization_en = {
	GKC_title = "Global Kill Counter",
	GKC_type_title = "Counter Type",
	GKC_type_desc = "Counter Type",
	id_GKC_type_1 = "Count Up",
	id_GKC_type_2 = "Count Down From ROBBEDACOP",
	id_GKC_type_3 = "Percentage of ROBBEDACOP",
	GKC_text_title = "Text in hud",
	GKC_text_desc = "Text in hud",
	GKC_font_size_title = "Text Size",
	GKC_font_size_desc = "Text Size",
	GKC_hud_x_title = "Counter Display X",
	GKC_hud_x_desc = "Counter Display X",
	GKC_hud_y_title = "Counter Display Y",
	GKC_hud_y_desc = "Counter Display Y",
	GKC_current_total_kills_title = "Total Kills",
	GKC_current_total_kills_desc = "Right click for value input, (it wont refresh but still works)",
	GKC_back = "Back",
	GKC_enter_name_title = "ENTER YOUR NAME", --unused
	GKC_enter_name_desc = "..." --unused
}

--Global.game_settings.difficulty
GKC.difficulty_multipliers = {
	easy = 0.5,
	normal = 1,
	overkill = 2,
	overkill_145 = 4,
	easy_wish = 6,
	overkill_290 = 7,
	sm_wish = 10
}

GKC.popups_count = 0
GKC.current_score = 0
GKC.current_level = "GKC_unknown_level"
GKC.current_gamemode = "GKC_unknown_gamemode"

local headshot_multiplier = 1 --not used, but you can enable it by setting your own headshot multiplier

--settings

function GKC:IsHUDCompatibilityMode()
	return self.settings.hud_compatibility_mode
end

--utils


function GKC:Log(...)
	if not self.settings.show_logs then 
		return
	end
	if Console then 
		Console:Log(...)
	else
		log(...)
	end
end

function GKC:len(s,b)
	if alive(self._kill_counter_base) then 
		local text = self._kill_counter_base:child("GKC_debug_text")
		text:set_text(tostring(s))
		local _,_,w,_ = text:text_rect()
		return w
	end
	return b
end

function GKC.FormatTime(t,b)
	if type(t) ~= "number" then 
		return b
	end
	
	local minutes = t / 60
	local hours = minutes / 60
	local days = hours / 24
	
	minutes = math.floor(minutes % 60)
	hours = math.floor(hours % 24)
	days = math.floor(days)
	
	local result = ""
	
	result = math.floor(t % 60) .. "s" --seconds
	
	if minutes > 0.1 then 
		result = minutes .. "m " .. result
	end
	if hours > 0.1 then 
		result = hours .. "h " .. result
	end
	if days > 0.1 then 
		result = days .. "d " .. result .. "- Wait, really? Holy crap."
	end
	return result
end

function GKC.FormatDateOf(d)
	if d then 
		local mm = string.sub(d,1,2)
		local dd = string.sub(d,3,4)
		local yyyy = string.sub(d,5,8)
		return string.format("%02d/%02d/%04d", mm, dd, yyyy)
	else
		return "01/01/1999"
	end
end

function GKC:CreateHUD(parent)
	if self:IsHUDCompatibilityMode() then 
		if not parent then 
			if self._workspace then 
				self:Log("Attempted to create GKC HUD again!")
				parent = self._workspace
			else
				self._workspace = managers.gui_data:create_fullscreen_workspace()
				parent = self._workspace:panel()
			end
		end
	else
		self._workspace = false
		parent = parent or managers.hud and managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2) and managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2).panel
	end
	if not parent then 
		return
	end
	if alive(parent:child("globalKillCounter_base")) then 
		parent:remove(parent:child("globalKillCounter_base"))
	end
	
	local GKC_base = parent:panel({
		name = "globalKillCounter_base",
		halign = "grow",
		valign = "bottom"
	})
	
	local GKC_debug_text = GKC_base:text({
		name = "GKC_debug_text",
		text = "",
		font = tweak_data.hud.medium_font,
		font_size = 16,
		color = Color.white,
		visible = false,
	})
	
	

	self._kill_counter_base = GKC_base

	local text = ""
	if GKC.settings.type == 1 then
		text = GKC.settings.text .. GKC.settings.kills
	elseif GKC.settings.type == 2 then
		text = GKC.settings.text .. tostring(GKC.neededKills - tonumber(GKC.settings.kills))
	elseif GKC.settings.type == 3 then
		text = GKC.settings.text .. tostring(math.floor(tonumber(GKC.settings.kills)*10000 / GKC.neededKills )/100)
	end
		
	local counter_value = GKC_base:text({
		name = "counter",
		layer = 1,
		text = tostring(text),
		font = "fonts/font_large_mf",
		font_size = 24,
		x = 0, --changed on loading into the heist (event playermanager:internal_load())
		y = 0,
		alpha = 1,
		color = Color.white
	})
	
	
	managers.hud:remove_updator("globalkillcounter_updator") --if present, remove updator
	managers.hud:add_updator("globalkillcounter_updator",callback(self,self,"UpdateHUD"))
end

function GKC:SetHUDVisible(state)
	if self._kill_counter_base and alive(self._kill_counter_base) then 
		if state == nil then 
			return			
		else
			self._kill_counter_base:set_visible(state)
			return
		end
	end
end


function GKC:UpdateHUD(t,dt)
	if not managers.player:local_player() then 
		self:SetHUDVisible(false)
		return
	end
	
	self:SetHUDVisible(true)
	
	-- local iteration = 0 --in effect, row number. disabled for "Bob" style 
	-- local v_margin = 16 --space per row
	-- local v_offset = 0 --total delta y after calculations
	-- local queued_cull = {}

	-- local base = self._kill_counter_base
	-- for queue_id,popup_id in pairs(queued_cull) do 
	-- 	base:remove(self.popups[popup_id].element)
	-- 	self.popups[popup_id] = nil
	-- end
end

function GKC:OnMissionEnd(data,session_time) --save highscore
	local base = self._kill_counter_base
	local counter = base:child("counter")
	counter:set_y(-10000)
end

function GKC:OnKill()
	globalKillCounter.settings.kills = globalKillCounter.settings.kills + 1
	GKC:Save()
	if globalKillCounter.settings.type == 1 then
		GKC:SetGobalKillCounter(globalKillCounter.settings.text .. globalKillCounter.settings.kills)
	elseif globalKillCounter.settings.type == 2 then
		GKC:SetGobalKillCounter(globalKillCounter.settings.text .. tostring(globalKillCounter.neededKills - tonumber(globalKillCounter.settings.kills)))
	elseif globalKillCounter.settings.type == 3 then
		GKC:SetGobalKillCounter(globalKillCounter.settings.text .. tostring(math.floor(tonumber(globalKillCounter.settings.kills)*10000 / globalKillCounter.neededKills )/100))
	end
end

function GKC:SetGobalKillCounter(str)
	local base = self._kill_counter_base
	local counter = base:child("counter")	
	counter:set_text(str)
end

function GKC:SetGobalKillCounterFontSize(val)
	local base = self._kill_counter_base
	if val and alive(base) then 
		local counter = base:child("counter")
		counter:set_font_size(val)
	end
end

function GKC:SetGobalKillCounterHudX(val)
	local base = self._kill_counter_base
	if val and alive(base) then 
		local counter = base:child("counter")
		counter:set_x(val)
	end
end

function GKC:SetGobalKillCounterHudY(val)
	local base = self._kill_counter_base
	if val and alive(base) then 
		local counter = base:child("counter")
		counter:set_y(val)
	end
end


function GKC:Load()

	local settings_file = io.open(GKC._saved_settings_path,"r")
	
	if not settings_file then return false end
	local  fileT= settings_file:read("*all"):gsub("%[%]","{}")
	settings_file : close()
	if 	   fileT == "" then return end
	

	GKC.settings = json.decode(fileT)

	return true
end
GKC:Load()

function GKC:Save()
	local settings_file = io.open(GKC._saved_settings_path,"w+")
	if settings_file then
		settings_file:write(json.encode(self.settings))
		settings_file:close()
	end
end
GKC:Save()

Hooks:Add("BaseNetworkSessionOnLoadComplete","GKC_ongameloadcomplete",function()
	if managers.hud then
		globalKillCounter:CreateHUD()
		globalKillCounter:SetGobalKillCounterFontSize(globalKillCounter.settings.font_size)
		globalKillCounter:SetGobalKillCounterHudX(globalKillCounter.settings.hud_x)
		globalKillCounter:SetGobalKillCounterHudY(globalKillCounter.settings.hud_y)
		if globalKillCounter._kill_counter_base and alive(globalKillCounter._kill_counter_base) then
			if not (game_state_machine and GameStateFilters.any_ingame[game_state_machine:current_state_name()]) then
				globalKillCounter:SetHUDVisible(false)
			end
		end
	end
end)

Hooks:Add("LocalizationManagerPostInit", "GKC_LocalizationManagerPostInit", function( loc )
--[[ TODO. if you want to help translate this to other languages, contact me and i'd be happy to implement your changes!

	local path = GKC.loc_path
	
	for _, filename in pairs(file.GetFiles(path)) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(path .. filename)
			return
		end
	end
	loc:load_localization_file(path .. "localization/english.txt")
	--]]
	loc:add_localized_strings(GKC.localization_en)
end)

Hooks:Add( "MenuManagerInitialize", "GKC_MenuManagerInitialize", function(menu_manager)
	MenuCallbackHandler.callback_GKC_type = function(self,item)
		GKC.settings.type = item:value()
		GKC:Save()
	end
	
	MenuCallbackHandler.callback_GKC_text = function(self,item)
		GKC.settings.text = item:value()
		GKC:Save()
	end

	MenuCallbackHandler.callback_GKC_font_size = function(self,item)
		item:set_value(math.floor(item:value()))
		GKC.settings.font_size = item:value()
		if alive(globalKillCounter._kill_counter_base) then 
			globalKillCounter:SetGobalKillCounterFontSize(GKC.settings.font_size)
		end
		GKC:Save()
	end

	MenuCallbackHandler.callback_GKC_hud_x = function(self,item)
		GKC.settings.hud_x = item:value()
		if alive(globalKillCounter._kill_counter_base) then 
			globalKillCounter:SetGobalKillCounterHudX(item:value())
		end
		GKC:Save()
	end
	
	MenuCallbackHandler.callback_GKC_hud_y = function(self,item)
		GKC.settings.hud_y = item:value()
		if alive(globalKillCounter._kill_counter_base) then 
			globalKillCounter:SetGobalKillCounterHudY(item:value())
		end
		GKC:Save()
	end

	MenuCallbackHandler.GKC_current_total_kills_callback = function(self,item)
		item:set_value(math.floor(item:value()))
		GKC.settings.kills = item:value()
		GKC:Save()
	end
	
	GKC:Load()
	
	MenuHelper:LoadFromJsonFile(GKC._options_path, GKC, GKC.settings)
end)